/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
#include "Os_Cfg.h"
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"

/* USER CODE BEGIN (1) */
uint32_t Counter20ms1_Task;
uint32_t Counter50ms1_Task;
uint32_t Counter100ms1_Task;

/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
/* USER CODE END */

int main(void)
{
/* USER CODE BEGIN (3) */
    gioInit();

    /********** OS **********/
    /* Create all the Tasks */
    vTaskInit();
    /* Create and start the software timer. */
    vTimerInit();
    /* Create the Group Events */
    xEventGroup = xEventGroupCreate();
    /* Start Scheduler */
    vTaskStartScheduler();

    /* Run forever */
    while(1);

/* USER CODE END */

    //return 0;
}


/* USER CODE BEGIN (4) */
/* 1.0032 msec Delay */
void Delay_1ms(void)
{
    int i, j;
    for(i = 0; i<20; i++)
    {
        for(j=0; j<1090; j++)
        {}
    }
}

/* 100 usec Delay */
void Delay_100us(void)
{
    int i, j;
    for(i = 0; i<2; i++)
    {
        for(j=0; j<1090; j++)
        {}
    }
}


void vEv_20ms1_Task(void *pvParameters)
{
    EventBits_t xEventGroupValue;
    const EventBits_t xBitsToWaitFor = TASK1_20MS1_BIT;
    int i;
    while(1)
    {
        xEventGroupValue = xEventGroupWaitBits( /*Event group to read*/
                                        xEventGroup,
                                        xBitsToWaitFor,
                                        pdTRUE,
                                        pdFALSE, // Event flag will be cleared
                                        xDelayms(20));  // shoud be less than task period, otherwise this will overcome task period

        if((xEventGroupValue & TASK1_20MS1_BIT)!=0)
        {
            Counter20ms1_Task++;
            gioSetBit(gioPORTB, 2, gioGetBit(gioPORTB, 2) ^ 1);
            // Runnable
            for(i=0; i<5; i++)
                Delay_1ms();
        }
    }
}

void vEv_50ms1_Task(void *pvParameters)
{
    EventBits_t xEventGroupValue;
    const EventBits_t xBitsToWaitFor = TASK1_50MS1_BIT;

    while(1)
    {
        xEventGroupValue = xEventGroupWaitBits( /*Event group to read*/
                                            xEventGroup,
                                            xBitsToWaitFor,
                                            pdTRUE,
                                            pdFALSE, // Event flag will be cleared
                                            xDelayms(50));  // shoud be less than task period, otherwise this will overcome task period

        if((xEventGroupValue & TASK1_50MS1_BIT)!=0)
        {
            Counter50ms1_Task++;
            //gioSetBit(gioPORTB, 2, gioGetBit(gioPORTB, 2) ^ 1);
            // Runnable
            Delay_1ms();
        }
    }
}

void vEv_100ms1_Task(void *pvParameters)
{
    EventBits_t xEventGroupValue;
    const EventBits_t xBitsToWaitFor = TASK1_100MS1_BIT;
    // const TickType_t xDelay100ms = pdMS_TO_TICKS( 100UL );
    while(1)
    {
        xEventGroupValue = xEventGroupWaitBits( /*Event group to read*/
                                            xEventGroup,
                                            xBitsToWaitFor,
                                            pdTRUE,
                                            pdFALSE, // Event flag will be cleared
                                            xDelayms(100));  // shoud be less than task period, otherwise this will overcome task period

        if((xEventGroupValue & TASK1_100MS1_BIT)!=0)
        {
            //gioSetBit(gioPORTB, 2, gioGetBit(gioPORTB, 2) ^ 1);
            // Runnable
            Counter100ms1_Task++;
            Delay_1ms();
        }
    }
}

/************ Idle Hook *************/
vApplicationIdleHook()
{
    /* Do Nothing */
}

/* USER CODE END */
